#include <stdio.h>


extern long long tim(void);
extern void parm3(void);
extern void parm2(void);
extern void parm1(void);
extern void parm0(void);
extern void p0lea(void);
extern void p0pop(void);

#define TRIES 0x1000
#define BIGPOS (1LL << 62)

int main(void);

int main()
{
    size_t i;
    long long overhead;
    long long shortest;
    long long p3, p2, p1, p0;


    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        overhead = tim();
        if(shortest > overhead)
            shortest = overhead;
    }
    shortest = overhead;


    printf("Timer overhead = %lld CPU clocks\n", overhead);

    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        parm3();
        p3 = tim();
        if(shortest > p3)
           shortest = p3;
    }
    p3 = shortest;
    p3 -= overhead;

    printf("push 3, pop 3 = %lld CPU clocks\n", p3);

    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        parm2();
        p2 = tim();
        if(shortest > p2)
           shortest = p2;
    }
    p2 = shortest;
    p2 -= overhead;

    printf("push 3, pop 2 = %lld CPU clocks\n", p2);

    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        parm1();
        p1 = tim();
        if(shortest > p1)
           shortest = p1;
    }
    p1 = shortest;
    p1 -= overhead;

    printf("push 3, pop 1 = %lld CPU clocks\n", p1);

    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        parm0();
        p0 = tim();
        if(shortest > p0)
           shortest = p0;
    }
    p0 = shortest;
    p0 -= overhead;

    printf("push 3, pop none using ADD = %lld CPU clocks\n", p0);

    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        p0lea();
        p0 = tim();
        if(shortest > p0)
           shortest = p0;
    }
    p0 = shortest;
    p0 -= overhead;

    printf("push 3, pop none using LEA = %lld CPU clocks\n", p0);
    for(i=0, shortest = BIGPOS; i < TRIES; i++)
    {
        (void)tim();
        p0pop();
        p0 = tim();
        if(shortest > p0)
           shortest = p0;
    }
    p0 = shortest;
    p0 -= overhead;

    printf("push 3, pop into same register = %lld CPU clocks\n", p0);

    return 0;
}
